SuperLU: EXAMPLE/citersol1.c File Reference

SuperLU 5.3.0

Functions | Variables
citersol1.c File Reference

Example #2 showing how to use ILU to precondition GMRES. More...

`#include "slu_cdefs.h"`
Include dependency graph for citersol1.c:

## Functions
void | cpsolve (int n, complex x[], complex y[])
void | cmatvec_mult (complex alpha, complex x[], complex beta, complex y[])
int | main (int argc, char *argv[])

## Variables
char * | GLOBAL_EQUED
superlu_options_t * | GLOBAL_OPTIONS
float * | GLOBAL_R
float * | GLOBAL_C
int * | GLOBAL_PERM_C
int * | GLOBAL_PERM_R
SuperMatrix * | GLOBAL_A
SuperMatrix * | GLOBAL_A_ORIG
SuperMatrix * | GLOBAL_L
SuperMatrix * | GLOBAL_U
SuperLUStat_t * | GLOBAL_STAT
mem_usage_t * | GLOBAL_MEM_USAGE

## Detailed Description

Copyright (c) 2003, The Regents of the University of California, through Lawrence Berkeley National Laboratory (subject to receipt of any required approvals from U.S. Dept. of Energy)

All rights reserved.

The source code is distributed under BSD license, see the file License.txt at the top-level directory.

    -- SuperLU routine (version 5.0) --
    Lawrence Berkeley National Laboratory
    November, 2010
    August, 2011

    This example shows that ILU is computed from the equilibrated matrix,
    but the preconditioned GMRES is applied to the original system.
    The driver routine CGSISX is called twice to perform factorization
    and apply preconditioner separately.

    Note that CGSISX performs the following factorization:
        Pr*Dr*A*Dc*Pc^T ~= LU
    with Pr being obtained from MC64 statically then partial pivoting
    dynamically. On return, A is overwritten as A1 = Dr*A*Dc.

    We need to save a copy of the original matrix A, then solve
    the original system, A*x = B, using FGMRES.
    Each GMRES step requires requires 2 procedures:
      1) Apply preconditioner M^{-1} = Dc*Pc^T*U^{-1}*L^{-1}*Pr*Dr
      2) Matrix-vector multiplication: w = A*v

## Function Documentation

## ◆ cmatvec_mult()

void cmatvec_mult | ( | complex | alpha,
|  | complex | x[],
|  | complex | beta,
|  | complex | y[]
| ) |  |

Here is the call graph for this function:

## ◆ cpsolve()

void cpsolve | ( | int | n,
|  | complex | x[],
|  | complex | y[]
| ) |  |

Here is the call graph for this function:

## ◆ main()

int main | ( | int | argc,
|  | char * | argv[]
| ) |  |

Here is the call graph for this function:

## Variable Documentation

## ◆ GLOBAL_A

SuperMatrix* GLOBAL_A

## ◆ GLOBAL_A_ORIG

SuperMatrix * GLOBAL_A_ORIG

## ◆ GLOBAL_C

float * GLOBAL_C

## ◆ GLOBAL_EQUED

char* GLOBAL_EQUED

## ◆ GLOBAL_L

SuperMatrix * GLOBAL_L

## ◆ GLOBAL_MEM_USAGE

mem_usage_t* GLOBAL_MEM_USAGE

## ◆ GLOBAL_OPTIONS

superlu_options_t* GLOBAL_OPTIONS

## ◆ GLOBAL_PERM_C

int* GLOBAL_PERM_C

## ◆ GLOBAL_PERM_R

int * GLOBAL_PERM_R

## ◆ GLOBAL_R

float* GLOBAL_R

## ◆ GLOBAL_STAT

SuperLUStat_t* GLOBAL_STAT

## ◆ GLOBAL_U

SuperMatrix * GLOBAL_U